#ifndef _H_RED_STAT
#define _H_RED_STAT

#include <stdint.h>

#define REDS_STAT_SHM_NAME "/spice.%u"
#define REDS_STAT_SHM_NAME_LENGTH 30

#define REDS_MAX_STATISTICS_COUNTERS 30
#define REDS_MAX_COUNTER_NAME_LENGTH 50

enum {
    REDS_COUNTER_FLAG_ENABLED = (1 << 0),
    REDS_COUNTER_FLAG_VISIBLE = (1 << 1),
};

typedef struct RedsCounter {
    char name[REDS_MAX_COUNTER_NAME_LENGTH];
    uint64_t value;
    uint8_t flags;
} RedsCounter;

typedef struct RedsStatValue {
    uint32_t value;
    uint32_t min;
    uint32_t max;
    uint32_t average;
    uint32_t count;
} RedsStatValue;

#ifdef RED_STATISTICS
void stat_add_counter(void **counter, const char *name, int visible,
                      const char *prefix, int index);
void stat_inc_counter(void *counter, int value);
#else
#define stat_add_counter(c, n, v, p, i)
#define stat_inc_counter(c, v)
#endif

#endif

